import dataclasses
from typing import Any

from obspy import UTCDateTime


class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKCYAN = '\033[96m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    BOLD = '\033[1m'
    UNDERLINE = '\033[4m'


def print_warning(message, *args, **kwargs):
    print(bcolors.WARNING + message + bcolors.ENDC, *args, **kwargs)


def print_error(message, *args, **kwargs):
    print(bcolors.FAIL + message + bcolors.ENDC, *args, **kwargs)


def packet_reader_placeholder(*args: Any, **kwargs: Any) -> None:
    """
    Placeholder function to be used in place of an RT130 packet reader
    function. This function immediately returns None.
    """
    return None


class RT130ParseError(Exception):
    pass


@dataclasses.dataclass
class PacketHeader:
    packet_type: str
    experiment_number: int
    unit_id: str
    time: UTCDateTime
    byte_count: int
    packet_sequence: int
